/*
 * $Id$
 * Created: Sep 12, 2006
 *
 * Copyright 2006, TmaxSoft Co., Ltd. All Rights Reserved.
 */
package ejb;

import entity.*;

import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;
import javax.ejb.Stateless;
import java.util.Vector;

/**
 * @author Wonseok Kim
 */
@Stateless
public class TestBean implements Test {
    @PersistenceContext
    EntityManager em;

    private Class[] entityClasses = {EntityA1.class, EntityA2.class, EntityB1.class, EntityB2.class,
                                     EntityC1.class, EntityC2.class, EntityD.class};
    private Class[] nonEntityClasses = {NonEntity.class};
    
    public boolean test() {
        boolean result = true;
        for(int i=0; i<entityClasses.length; i++){
            try {
                em.find(entityClasses[i], "key");
            } catch(IllegalArgumentException ex){
                result = false;
                log("FAIL: " + entityClasses[i].getName() + " should be entity class");
            }
        }
        
        for(int i=0; i<nonEntityClasses.length; i++){
            try {
                em.find(nonEntityClasses[i], "key");
                result = false;
                log("FAIL: " + nonEntityClasses[i].getName() + " should not be entity class");
            } catch(IllegalArgumentException ex){
                //expected
            }
        }

        return result;
    }
    
    private void log(String msg){
        System.err.println(msg);
    }
}
